import java.util.*;
import java.net.*;
import java.util.concurrent.*;

public class Sample {
  public static String getNameOfAirport(String iata) {
    /*
    try {
      var url = "https://soa.smext.faa.gov/asws/api/airport/status/" + iata;

      try(var scanner = new Scanner(new URI(url).toURL().openStream())) {
        var response = scanner.nextLine();

        if(!response.contains("Name")) {
    	  throw new RuntimeException("Invalid airport code " + iata);
        }

        return response.split("\"")[3];
      }
       */

       var mockData = Map.of(
         "AUS", "Austin", "IAH", "Houston", "DFW", "Dallas", "SAT", "San Antonio");

        var name = mockData.get(iata);

	if(name == null) {
	  throw new RuntimeException("Invalid airport code " + iata);
	}

	return name;
    //} catch(Exception ex) {
    //  throw new RuntimeException(ex);
    //}
  }


  public static void main(String[] args) {
    try {
      List<String> iataCodes = List.of("AUS", "IAH", "DFW", "TAS", "SAT");

      var executorService = Executors.newFixedThreadPool(10);
      var futures = new ArrayList<Future<String>>();

      for(var iataCode: iataCodes) {
        futures.add(executorService.submit(() -> getNameOfAirport(iataCode))); 
      }

      for(var future: futures) {
        System.out.println(future.get());
      }

      executorService.shutdown();
      executorService.awaitTermination(10, TimeUnit.SECONDS);
    } catch(Exception ex) {
      System.out.println(ex.getMessage());
    }
  }
}

//If there is an exception that is not communicated properly to deal
//with the overall task.
//If one thread fails, there is no way to tell the other tasks not to continue.
//There was no clear relationship between the tasks that were scheduled using these thread in the pool.




