import java.util.*;
import jdk.incubator.concurrent.*;

public class Sample {
  public final ScopedValue<Boolean> state = ScopedValue.newInstance();

  public static void main(String[] args) throws Exception {
    new Sample().execute();
  }

  public void execute() throws Exception {
    System.out.println("bind a value to the scoped value");

    var stateValue = !state.isBound();

    ScopedValue.where(state, stateValue)
      .run(this::process);

    //process(); //ERROR

    //ScopedValue.where(state, false)
    //  .run(this::process);

    System.out.println(ScopedValue.where(state, true)
      .call(this::compute));
  }

  public void process() {
    doWork();
  }

  public void doWork() {
    System.out.println("Thread: " + Thread.currentThread());
    System.out.println("doing work with the state " + state.get());

    if(state.get()) {
      System.out.println("will call back again");
      try {
        execute();
      } catch(Exception ex) {
        System.out.println(ex);
      }
    } else {
      System.out.println("will not call back again");
    }
  }

  public int compute() {
    return state.get() ? 5 : 6;
  }
}
